#!/usr/bin/ruby
# file name  : nabazrok.rb
# authors    : Jean-Francois Lalande (jf *at* lalande . nom . fr)
# created    : mar 22 avr 2008 18:18:14 CEST
# copyright  : Ensi de Bourges
#
# Todo first:
$:.unshift(File.dirname(__FILE__))
root = File.join(File.dirname(__FILE__))
require 'net/http'
require "#{root}/kdialog.rb"

# Proxy configuration
PROXY=0 # Turn this to 1 to send the HTTP request to a Proxy
IPPROXY='127.0.0.1' # Set this to ip address of your proxy
IPPORTNUMBER=8888 # Set this to the port of your proxy listens on

def myConfig(sn_,token_)

    if sn_ == nil
	sn_ == ""
    end
    if token_ == nil
	token == ""
    end

    dlg = KDialog.new("Nabaztag configuration information")
    sn = dlg.inputbox("Nabaztag serial number",sn_)
    if sn == "\n" 
      exit() 
    end
    sn = sn.gsub(/ /,'')

    dlg = KDialog.new("Nabaztag configuration information")
    token = dlg.inputbox("Nabaztag token",token_)
    if token == "\n" 
      exit() 
    end
    token = token.gsub(/ /,'')

    lang = dlg.menu("Select a language",["English","French"])
    if lang == "\n" 
      exit() 
    end

    if lang == "English"
      voice = dlg.menu("Select a voice",["julie22k","claire22k","caroline22k","bruno22k"])
    else
      voice = dlg.menu("Select a voice",["graham22k","lucy22k","heather22k","ryan22k","laura22k"])
    end
    if voice == "\n" 
      exit() 
    end

    sentence = dlg.inputbox("I will say...", "Playing... *title*, by *artist* from *albumtitle*.")
    if sentence == "\n"
      exit()
    end
    config = File.new("nabazrok.conf", "w")
    config.puts sn
    config.puts token
    config.puts lang
    config.puts voice
    config.puts sentence
    config.close()

end

# Main prog
begin
    begin
	file = File.new("nabazrok.conf", "r")
	sn = file.gets
	sn = sn.gsub(/\n/,'')
	token = file.gets
	token = token.gsub(/\n/,'')
	lang = file.gets
	lang = lang.gsub(/\n/,'')
	voice = file.gets
	voice = voice.gsub(/\n/,'')
	sentence = file.gets
	sentence = sentence.gsub(/\n/,'')
	file.close
    rescue
    end

    if lang == nil or voice == nil or sentence == nil or sn == nil or token == nil
	myConfig("","")
    end
end while lang == "" or voice == "" or sentence == ""

loop do
    message = gets().chomp() #Read message from stdin
    command = /[A-Za-z]*/.match( message ).to_s()

    case command
        when "configure"
	    myConfig(sn,token)
	    exit()

        when "trackChange"
	    artist = `dcop amarok player artist`
	    artist = artist.gsub(/\n/,'')
	    title = `dcop amarok player title`
	    title = title.gsub(/\n/,'')
	    albumtitle = `dcop amarok player album`
	    albumtitle = albumtitle.gsub(/\n/,'')
	    trackTotalTime = `dcop amarok player trackTotalTime`
	    trackTotalTime = trackTotalTime.gsub(/\n/,'')
	    monmessage = #"Playing: " + title + ", by " + artist + "."
	    monmessage = sentence
	    monmessage = monmessage.gsub('*title*',title)
	    monmessage = monmessage.gsub('*artist*',artist)
	    monmessage = monmessage.gsub('*albumtitle*',albumtitle)
	    monmessage = monmessage.gsub(/ /,'+')
	    monmessage2 = monmessage.gsub(/ /,'+')
	    url = "http://api.nabaztag.com" + "/vl/FR/api.jsp?token=" + token + "&sn=" + sn + "&ttlive=" + trackTotalTime + "&voice=" + voice + "&tts=" +  monmessage2
	    url = URI.escape(url)
	    if trackTotalTime.to_i > 30
        begin
          if PROXY == 1
            proxy = Net::HTTP::Proxy(IPPROXY, IPPORTNUMBER)
            res = proxy.get_response(URI.parse(url))
          else
            res = Net::HTTP.get_response(URI.parse(url))
          end

          #logfile = File.new("nabazrok.log", "a")
          #logfile.puts "Sending: " + url
          #logfile.puts res
          #logfile.close()
        rescue
          logfile = File.new("nabazrok.log", "a")
          logfile.puts "Error sending: " + url
          logfile.close()
        end
	    end
    end
end

